part of viltage;

class Collidable {
  List<CharNode> nodes = new List<CharNode>();
  
  static bool collides(int offX, int offY, int offX2, int offY2, Collidable c1, Collidable c2) {
    for(int i = 0; i < c1.nodes.length; i++) {
      for(int j = 0; j < c2.nodes.length; j++) {
        if(c1.nodes[i].x + offX == c2.nodes[j].x + offX2 && c1.nodes[i].y + offY == c2.nodes[j].y + offY2) return true;
      }
    }
    return false;
  }
  
  add(var charNodes) {
    if(charNodes is CharNode) {
      nodes.add(charNodes);
    } else if (charNodes is List<CharNode>) {
      for(int i = 0; i < charNodes.length; i++)
        nodes.add(charNodes[i]);
    } else if (charNodes is List<List<CharNode>>) {
      for(int i = 0; i < charNodes.length; i++)
        for(int j = 0; j < charNodes[i].length; j++)
        nodes.add(charNodes[i][j]);
    }
  }
}